love.graphics.setDefaultFilter("nearest", "nearest")
res = require('lib.cargo').init('res')(true)
require "maploader"
--require "lib.strict"
require "lib.tick" -- fixed time step
Class = require "lib.hump.class"
Camera = require "lib.hump.camera"
Player = require("player")
lume = require "lib.lume"
local bump = require "lib.bump"
love.graphics.setLineStyle("rough")
gw, gh = 320, 320
local bgquad = love.graphics.newQuad( 0, 0, gw, gh*2, 44, 44 )
local canvas = love.graphics.newCanvas(gw, gh)
local scale = 3
love.window.setMode(gw * scale, gh * scale, {resizable=true, vsync=true, minwidth=gw, minheight=gh})
world = nil
local player = nil
actors = {}
map = nil
--print = function(s) os.execute("notify-send "..'"' .. s .. '"') end

function love.load()
  actors = {}
  res.images.bg:setWrap("repeat", "repeat")
  map = loadTiledMap("map0")
  player = Player()
  camera = Camera(player.x,player.y)
  world = bump.newWorld()
  map:setupColliders(world)
  world:add(player, player.x, player.y, 4, 4)
  table.insert(actors, player)
end

local function distance(x1, y1, x2, y2, squared)
  local dx = x1 - x2
  local dy = y1 - y2
  local s = dx * dx + dy * dy
  return squared and s or math_sqrt(s)
end

function love.update(dt)
  print(camera:cameraCoords(player.x, player.y))
  player:update(dt)
  local cx, cy = camera:mousePosition()
  --camera:lookAt((player.x*scale + cx)/2, (player.y*scale + cy)/2)
  --camera:lookAt((player.x*scale + cx)/2, (player.y*scale + cy)/2)
  camera:lookAt(player.x, player.y)
  map:update()
end

function love.draw()
  --love.graphics.setCanvas(canvas)
  camera:attach()
  --
  love.graphics.draw(res.images.bg, bgquad, 0, -love.timer.getTime()*10%44*-2)
  map:draw()
  table.sort(actors, function(a,b) return a.y < b.y end)
  for i,a in ipairs(actors) do a:draw() end
  --
  camera:detach()
  love.graphics.setCanvas()
  love.graphics.draw(canvas, 0, 0, 0, scale, scale);
  love.graphics.print(love.timer.getFPS(),0,32)
  --love.graphics.draw(res.images.hc2, 0, 0)
  end

function love.keypressed(key)
  if key == 'escape' then return love.event.quit() end
  if key == "r" then love.load() end
end
