Class = require "lib.hump.class"
local player = Class{}

function player:init()
  self.x = gw / 2
  self.y = gh * 0.5
  self.norm = 1/math.sqrt(2)
  self.speed = 120
end

function player:update(dt)
  local key = function(k) return love.keyboard.isDown(k) and 1 or 0 end
  local vx, vy = key("right") - key("left"), key("down") - key("up")
  if vx ~= 0 and vy ~= 0 then vx, vy = vx * self.norm, vy * self.norm end
  local goalX, goalY = self.x + vx * self.speed * dt, self.y + vy * self.speed *dt
  local actualX, actualY, cols, len = world:move(self, goalX, goalY, self.onCollision)
  self.x, self.y = actualX, actualY
  if len > 0 then
    for _, it in pairs(cols) do if it.other.stability then it.other.stability = 2 end end
  end
end

function player.onCollision(item, other)
  local result = "cross"
  if other and other.isWall then result = "slide" end
  return result
end

function player:draw()
  love.graphics.draw(res.images.sue, lume.round(self.x-8), lume.round(self.y-12))
  love.graphics.setColor(1,0,0)
  love.graphics.circle("fill",self.x, self.y,2)
  love.graphics.setColor(1,1,1)
end

return player
